using System;
using System.Collections;

namespace Algorithm
{
	public class ElementCollection : CollectionBase
	{
		public Element this[int index]
		{
			get { return (Element)List[index]; }
		}

		public int Add(Element element)
		{
			return List.Add(element);
		}

		public void Insert(int index, Element element)
		{
			List.Insert(index,element);
		}

		public void Remove(Element element)
		{
			int index = IndexOf(element);
			if(index >= 0) List.RemoveAt(index);
		}

		public bool Contains(Element element)
		{
			return (IndexOf(element) >= 0);
		}

		public int IndexOf(Element element)
		{
			for (int index = 0; index < List.Count; index++)
				if(element == List[index]) return index;
			return -1;
		}

		public void InsertOrder(Element element)
		{
			if (List.Count == 0)
			{
				List.Add(element);
				return;
			}
			for (int index = 0; index < List.Count; index++)
			{
				if (element.Distanza < ((Element)List[index]).Distanza)
				{
					List.Insert(index,element);
					return;
				}
			}
			List.Add(element);
		}
	}
}
